// This defines the class mesh
#ifndef _MESH
#define _MESH
#include <iostream>
#include "IBMRvecmat.h"
using namespace std;
// define the extents of our mesh
#define LEFT -0.8
#define BOTTOM -0.8
#define TOP 0.8
#define RIGHT 0.8

enum MODE {LINE, VERTEX, FILL};

struct PointP2
{
	Vec3 point;	// point in P2 space
	Vec2 tex;	// texture coordinates
};

class mesh
{
	private:
		int nX,nY; 	// number of vertices in X and Y direction
		PointP2 **grid2D;	// 2D array of points
	public:
		mesh();	// emply constructor
		mesh(int nx, int ny);	// constructor to initialize mesh
		void Initialize(int nx, int ny);	// initialize mesh -- same as constructor but standalone
		void Clear();	// clean mesh and empty memory
		int get_nX();	// get the number of vertices along X dimension
		int get_nY();	// get the number of vertices along Y dimension
		Vec3 getPoint(int x, int y);	// get the [x,y]th point's location
		Vec2 getTex(int x, int y);	// get the [x,y]th point's texture coordinate
		int ApplyTransform(Mat3 H);	// Apply and H matrix to the points
		void display();	// display the mesh using OpenGL -- will add texture later
		void reset();	// reset the mesh to what it was first initialized
};

#endif
